/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.perf.sample.webapp.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class CPUServlet extends HttpServlet {

	protected static Integer sLock = new Integer(1);
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		long number = 300000;
		long objective = 5000;
		
		for (int i = 0; i < objective; i++)
		{
			number++;
			boolean isPrime = true;
			for (int j = 2; j < number; j++)
			{
				if ( (number % j) == 0)
				{
					isPrime = false;
					break;
				}
			}
			if (isPrime)
			{
				// Cool, found a prime number : number
			}
		}
		
		req.getRequestDispatcher("/cpuResult.jsp").forward(req, resp);
	}
	
	

}
