/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.perf.sample.webapp.servlet;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class IOServlet extends HttpServlet {

	protected static Integer sLock = new Integer(1);
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		long fileSize = 1024*128; // 128 Mo
		byte[] bytes = new byte[1024];
		
		char c = 'a';
		byte b = (byte) c;
		
		for (int i = 0; i < 1024; i++)
		{
			bytes[i] = b;
		}
		
		File f = File.createTempFile("appspy", ".txt");
		
		try
		{
			FileOutputStream fos = new FileOutputStream(f);
			for (int i = 0; i < fileSize; i++)
			{
				fos.write(bytes);
			}
			fos.flush();
			fos.close();
			System.out.println(f.getAbsolutePath() + " : " + f.length());
		}
		finally
		{
			try
			{
				f.delete();
			}
			catch (Exception ex)
			{
			}
		}
		
		req.getRequestDispatcher("/ioResult.jsp").forward(req, resp);
	}
	
	

}
