/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.perf.sample.webapp.servlet;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class LockServlet extends HttpServlet {

	protected static Integer sLock = new Integer(1);
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		ArrayList<Thread> threads = new ArrayList<Thread>();
		for (int i = 0; i < 5; i++)
		{
			Thread t = new Thread(new Runnable(){

				public void run()
                {
					synchronized (sLock)
					{
						try {
							Thread.sleep(200);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
                }});
			threads.add(t);
			t.start();
		}
		
		for (int i = 0; i < 10; i++)
		{
			synchronized (sLock)
			{
				@SuppressWarnings("unused")
				int j = sLock*2;
			}
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		for (Thread thread : threads)
        {
	        try
            {
	            thread.join();
            } catch (InterruptedException e)
            {
	            e.printStackTrace();
            }
        }
				
		req.getRequestDispatcher("/lockResult.jsp").forward(req, resp);
	}
	
	

}
